/*
 * GuestGUI.java
 *
 * Created on 1. maj 2009, 09:42
 */
package hoteldeepsleep;

import guest.Guest;
import guest.GuestAdministration;
import guest.GuestCatalog;
import guest.ForeignGuest;
import guest.LocalGuest;
import Room.RoomAdministration;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import hdsdatabase.GuestAdministrationDB;

/**
 *
 * @author  admin
 */
public class GuestGUI extends javax.swing.JFrame {

    Guest g;
    GuestAdministration guestHandler;
    GuestAdministrationDB guestHandlerDB;
RoomAdministration roomHandler;
    /** Creates new form GuestGUI */
    public GuestGUI() {
        initComponents();
        guestHandler = new GuestAdministration();
        guestHandlerDB=new GuestAdministrationDB();
    }

    public GuestGUI(GuestCatalog guestCat) {
        initComponents();
        guestHandler = new GuestAdministration(guestCat);
    }

    public GuestGUI(GuestAdministration guestHandler) {
        initComponents();
        this.guestHandler = guestHandler;
    }

    GuestGUI(GuestAdministrationDB guestHandlerDB) {
        initComponents();
        this.guestHandlerDB=guestHandlerDB;
    }

    private void showNumbers() {
        int num = guestHandler.getNumbers();
        String numStr = new Integer(num).toString();
        dataArea.setText(numStr);
    }
      private void showNumbersDB() {
        int num = guestHandlerDB.noOfGuests();
        String numStr = new Integer(num).toString();
        dataArea.setText(numStr);
    }

    private void createGuest() {
        dataArea.setText("");
        Object[] possibleValuess = {"Foreign", "Local"};
        String type = (String) JOptionPane.showInputDialog(null, "Choose Guest Nationality", "Input",
                JOptionPane.QUESTION_MESSAGE, null, possibleValuess, possibleValuess[1]);
        if (type.equalsIgnoreCase("foreign")) {
            String resNoStr = JOptionPane.showInputDialog("State reservation number: ");
            int resNo = Integer.parseInt(resNoStr);
            String idNo = null;
            String name = JOptionPane.showInputDialog("State Guest's Name: ");
            String address = JOptionPane.showInputDialog("State Guest's Address: ");

            String zipcodeStr = JOptionPane.showInputDialog("State Zip Code: ");
            int zipcode = Integer.parseInt(zipcodeStr);

            String city = JOptionPane.showInputDialog("State City: ");
            String country = JOptionPane.showInputDialog("State Country: ");
            String passportNo = JOptionPane.showInputDialog("State Passport Number: ");

            String phoneNo = JOptionPane.showInputDialog("State Phone Number: ");
           

            String email = JOptionPane.showInputDialog("State E-mail Address: ");

            guestHandler.registerGuest(resNo,idNo,name, address, zipcode, city, country, passportNo, phoneNo, email);
 g=new ForeignGuest(name, address, zipcode, city, country, passportNo, phoneNo, email);
        } else if (type.equalsIgnoreCase("local")) {
            String resNoStr = JOptionPane.showInputDialog("State reservation number: ");
            int resNo = Integer.parseInt(resNoStr);
            String idNo = JOptionPane.showInputDialog("State idNo Of Guest: ");
            String name = JOptionPane.showInputDialog("State Guest's Name: ");
            String address = JOptionPane.showInputDialog("State Guest's Address: ");

            String zipcodeStr = JOptionPane.showInputDialog("State Zip Code: ");
            int zipcode = Integer.parseInt(zipcodeStr);

            String city = JOptionPane.showInputDialog("State City: ");
            String country = null;
            String passportNo = null;

            String phoneNo = JOptionPane.showInputDialog("State Phone Number: ");
            

            String email = JOptionPane.showInputDialog("State E-mail Address: ");
            guestHandler.registerGuest(resNo,idNo, name, address, zipcode, city, country, passportNo, phoneNo, email);
      
         g=new LocalGuest(idNo,name, address, zipcode, city,  phoneNo, email);
        }
        showNumbersDB();
        showGuestDB();
    }

 private void createGuestDB() throws SQLException {
        dataArea.setText("");
        Object[] possibleValuess = {"Foreign", "Local"};
        String type = (String) JOptionPane.showInputDialog(null, "Choose Guest Nationality", "Input",
                JOptionPane.QUESTION_MESSAGE, null, possibleValuess, possibleValuess[1]);
        if (type.equalsIgnoreCase("foreign")) {
            
            String idNo = null;
            String name = JOptionPane.showInputDialog("State Guest's Name: ");
            String address = JOptionPane.showInputDialog("State Guest's Address: ");

            String zipcodeStr = JOptionPane.showInputDialog("State Zip Code: ");
            int zipcode = Integer.parseInt(zipcodeStr);

            String city = JOptionPane.showInputDialog("State City: ");
            String country = JOptionPane.showInputDialog("State Country: ");
            String passportNo = JOptionPane.showInputDialog("State Passport Number: ");

            String phoneNo = JOptionPane.showInputDialog("State Phone Number: ");


            String email = JOptionPane.showInputDialog("State E-mail Address: ");
 g=new ForeignGuest(name, address, zipcode, city, country, passportNo, phoneNo, email);
 g.setGuestNo(guestHandlerDB.nextGuestNo());
            guestHandlerDB.registerGuest( idNo,  name,  address,  zipcode,
           city, country, passportNo,  phoneNo,
             email);

        } else if (type.equalsIgnoreCase("local")) {
           
            String idNo = JOptionPane.showInputDialog("State idNo Of Guest: ");
            String name = JOptionPane.showInputDialog("State Guest's Name: ");
            String address = JOptionPane.showInputDialog("State Guest's Address: ");

            String zipcodeStr = JOptionPane.showInputDialog("State Zip Code: ");
            int zipcode = Integer.parseInt(zipcodeStr);

            String city = JOptionPane.showInputDialog("State City: ");
            String country = "Denmark";
            String passportNo = null;

            String phoneNo = JOptionPane.showInputDialog("State Phone Number: ");


            String email = JOptionPane.showInputDialog("State E-mail Address: ");
             g=new LocalGuest(idNo,name, address, zipcode, city,  phoneNo, email);
            g.setGuestNo(guestHandlerDB.nextGuestNo());
            guestHandlerDB.registerGuest(idNo, name, address, zipcode,
                    city, country, passportNo, phoneNo, email);

        
        }
        showNumbers();
        showGuest();
    }

 

    private void searchGuest() {
        dataArea.append(" ");
String guestName = JOptionPane.showInputDialog("State guest name ");
           
        g = guestHandler.getGuest(guestName);
        if(g!=null){
        dataArea.setText(g.guestData());
        }
        else
            dataArea.setText("no guest found");
}
     private void searchGuestDB() {
        dataArea.append(" ");
String guestName = JOptionPane.showInputDialog("State guest name : ");

        g=guestHandlerDB.getGuest(guestName);
        if(g!=null){
        dataArea.setText(g.guestData());
        }
        else
            dataArea.setText("no guest found");
}



    private void deleteGuest() {

        int check = JOptionPane.showConfirmDialog(null, "Delete guest?", "Choose one", JOptionPane.YES_NO_OPTION);

        if (check == 0) {
    if (g.getIdNo()!=null){
        guestHandler.removeGuest(g.getGuestNo());
    }
    else
        guestHandler.removeGuest(g.getGuestNo());
            dataArea.setText("Guest deleted");
        } else {
            dataArea.setText("Guest not deleted");
        }
        showNumbers();

    }
 private void deleteGuestDB() {
       

            String guestNoStr = JOptionPane.showInputDialog("State guestNo: ");
            int guestNo = Integer.parseInt(guestNoStr);
           g=guestHandlerDB.getGuest1(guestNo);
        int check = JOptionPane.showConfirmDialog(null, "Delete guest?", "Choose one", JOptionPane.YES_NO_OPTION);

        if (check == 0) {
    if (g.getIdNo()!=null){
        guestHandlerDB.removeGuest(g.getGuestNo());
         dataArea.setText("Guest deleted");
    }
    else
        guestHandler.removeGuest(g.getGuestNo());
            dataArea.setText("Guest deleted");
        } else {
            dataArea.setText("Guest not deleted");
        }
        showNumbersDB();

    }

    private void showGuest(){
      
            dataArea.append(g.guestData());
      }
    private void showGuestDB(){
dataArea.setText(" ");
            dataArea.append(g.guestData());
      }
    private void showAllGuests(){
        dataArea.setText(" ");
        dataArea.append(guestHandler.allGuestsData());
    }
private void showAllGuestsDB(){
    dataArea.setText(" ");
        dataArea.append(guestHandlerDB.showAllGuests());
    }
private void processDeparture(){
   dataArea.append(" ");

 String guestNoStr = JOptionPane.showInputDialog("State Guest Number: ");
            int guestNo = Integer.parseInt(guestNoStr);
           g=guestHandler.getGuest(guestNo);
           dataArea.append(g.guestData());
 String lengthStr = JOptionPane.showInputDialog("State the number of days the guest has stayed ");
            int length = Integer.parseInt(lengthStr);

dataArea.append("total amount owed"+roomHandler.calculateBill(guestNo, length));
}

    private void closeWindow() {
        this.dispose();
    }

    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        createButton = new javax.swing.JButton();
        showButton = new javax.swing.JButton();
        showAllButton = new javax.swing.JButton();
        searchButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        dataArea = new javax.swing.JTextArea();
        closeButton = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        createButton.setText("Creat Guest");
        createButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createButtonActionPerformed(evt);
            }
        });

        showButton.setText("Show Guest");
        showButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showButtonActionPerformed(evt);
            }
        });

        showAllButton.setText("Show All Guests");
        showAllButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showAllButtonActionPerformed(evt);
            }
        });

        searchButton.setText("Search Guest");
        searchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchButtonActionPerformed(evt);
            }
        });

        dataArea.setColumns(20);
        dataArea.setRows(5);
        jScrollPane1.setViewportView(dataArea);

        closeButton.setText("Help");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jButton1.setText("Finish");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        deleteButton.setText("Delete Guest");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        jButton2.setText("Depart Guest");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton2, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)
                            .addComponent(createButton, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)
                            .addComponent(showButton, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)
                            .addComponent(showAllButton, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)
                            .addComponent(deleteButton, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)
                            .addComponent(searchButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                        .addGap(291, 291, 291)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(closeButton)
                            .addComponent(jButton1))
                        .addGap(6, 6, 6))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 375, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 166, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(createButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(showButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(showAllButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(searchButton)
                    .addComponent(jButton1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(closeButton)
                    .addComponent(jButton2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(deleteButton)
                .addGap(190, 190, 190))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(113, 113, 113)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 359, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void createButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createButtonActionPerformed
        try {
            // TODO add your handling code here:
            createGuestDB();
        } catch (SQLException ex) {
            Logger.getLogger(GuestGUI.class.getName()).log(Level.SEVERE, null, ex);
        }
}//GEN-LAST:event_createButtonActionPerformed

    private void showButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showButtonActionPerformed
        // TODO add your handling code here:
        showGuestDB();
    }//GEN-LAST:event_showButtonActionPerformed

    private void showAllButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showAllButtonActionPerformed
        // TODO add your handling code here:
        showAllGuestsDB();
    }//GEN-LAST:event_showAllButtonActionPerformed

    private void searchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchButtonActionPerformed
        // TODO add your handling code here:
        searchGuestDB();
    }//GEN-LAST:event_searchButtonActionPerformed

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
        // TODO add your handling code here:
        deleteGuestDB();
    }//GEN-LAST:event_deleteButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // TODO add your handling code here:
    
    }//GEN-LAST:event_closeButtonActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:'
            closeWindow();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
        processDeparture();
    }//GEN-LAST:event_jButton2ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new GuestGUI().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JButton createButton;
    private javax.swing.JTextArea dataArea;
    private javax.swing.JButton deleteButton;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton searchButton;
    private javax.swing.JButton showAllButton;
    private javax.swing.JButton showButton;
    // End of variables declaration//GEN-END:variables
}
