
package Reservation;


import Room.*;
import java.util.*;
import java.sql.Date.*;

public class ReservationCatalog extends Random {
    private LinkedList<Reservation> reservations;
    CalendarCalculator cc;
    Random rand;

    public ReservationCatalog() {
        reservations = new LinkedList<Reservation>();
        cc=new CalendarCalculator();
        rand=new Random();
    }

    public boolean registerReservation(String guestName, int roomNo,
                                 java.sql.Date dateFrom,java.sql.Date dateTo) {
        java.sql.Date reservationDate=cc.getResDate();
        int reservationNo=rand.nextInt(9001);
        Reservation aReservation = new Reservation(guestName, roomNo,
                                                 reservationNo, reservationDate,
                                                 dateFrom, dateTo);
        reservations.add(aReservation);
        return true;
    }

//    public boolean addReservation(Reservation aReservation) {
//        reservations.add(aReservation);
//        return true;
//    }
//public int getLengthOfStay(){
//Reservation r=new Reservation();
//Date to = r.getDateTo();
//Date from=r.getDateFrom();
//
//int leaveDay=to.getDay();
//int stayDay=from.getDay();
//int length=leaveDay-stayDay;
//    return length;
//}
    public Reservation removeReservation(int reservationNo) {
        Iterator i = reservations.listIterator();
        Reservation res = null;
        while (i.hasNext()) {
            res = (Reservation) i.next();
            if ((res.getReservationNo()) == (reservationNo)) {
                i.remove();
            }
        }
        return res;
    }

    public Reservation getReservation(int reservationNo) {
        Iterator i = reservations.listIterator();
        Reservation res = null;
        while (i.hasNext()) {
            res = (Reservation) i.next();
            if ((res.getReservationNo()) == (reservationNo)) {
                System.out.println(reservations.toString());
            }
        }
        return res;
    }

    public Reservation getReservation(String guestName, java.sql.Date reservationDate) {
        Iterator i = reservations.listIterator();
        Reservation res = null;
        while (i.hasNext()) {
            res = (Reservation) i.next();
            if ((res.getReservationDate().equals(reservationDate))&&
                                    (res.getGuestName().equals(guestName))) {
                System.out.println(reservations.toString());
            }
        }
        return res;
    }

    public void editReservation(String guestName, int roomNo, int reservationNo,
                            int newReservationNo, java.sql.Date reservationDate,
                               java.sql.Date dateFrom, java.sql.Date dateTo) {
        Iterator i = reservations.listIterator();
        Reservation res = null;
        while (i.hasNext()){
            res = (Reservation)i.next();
            if ((res.getReservationNo()) == (reservationNo)) {
                res.setGuestName(guestName);
                res.setRoomNo(roomNo);
                res.setReservstionNo(newReservationNo);
                res.setDateFrom(dateFrom);
                res.setDateTo(dateTo);
            }
        }
    }

public int getRoomNo(int resNo,String guestName){
   int roomNo=0;
   Reservation res;
   Iterator i= reservations.listIterator();
   while(i.hasNext()){
    res=(Reservation)i.next();
    if(res.getGuestName().equalsIgnoreCase(guestName)
            &&res.getReservationNo()==resNo){
        roomNo=res.getRoomNo();
    }

   }
    return roomNo;
}
public int searchRoom(String type, String category,Date to, Date from){
  int roomNo=0;
   Reservation res;
   Room r = null;
   RoomAdministration rH=new RoomAdministration();
   Iterator i= reservations.listIterator();
   while(i.hasNext()){
    res=(Reservation)i.next();
    if(r.getCategory().equalsIgnoreCase(category)&&
            r.getType().equalsIgnoreCase(category)
            && res.getDateTo().equals(to)&&res.equals(from)){
        r=rH.getRoom(type, category);
        roomNo=r.getRoomNo();
    
    }
   
   }
    return roomNo;
}
    public String allReservationsData() {
        String s = "";
        Reservation res = null;
        Iterator i = reservations.listIterator();
        while (i.hasNext()) {
            res =(Reservation)i.next();
            s = s + res.reservationData();
//               res.setReservationDate( reservationDate);
        }
        return s;
    }

    public int numberOfReservations(){
        return reservations.size();
    }

    public static void main(String[] args) {
        ReservationCatalog reservationCat = new ReservationCatalog();

        reservationCat.registerReservation("Sandeep", 101,
                                          java.sql.Date.valueOf ("2009-05-02"),
                                          java.sql.Date.valueOf("2009-05-05"));
          
        reservationCat.registerReservation("Wanling", 104, 
                                          java.sql.Date.valueOf("2009-05-03"),
                                          java.sql.Date.valueOf("2009-05-06"));

        System.out.println(reservationCat.allReservationsData());        
    }
}
