/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Room;

import java.util.*;
import guest.*;
import Reservation.*;

/**
 * Hotel Deepsleep project 2009
 * @author Wanling ,Grace,Sandeep,Jack
 * Roskilde Business College
 */
public class RoomCatalog {

    private ArrayList<Room> rooms;
GuestAdministration guestHandler;
ReservationAdministration resHandler;

    public RoomCatalog() {
        rooms = new ArrayList<Room>();
    }

    public boolean registerRoom(int roomNo, String type, String category,
                                String status, double price, String view) {
        Room aRoom = new Room(roomNo, type, category, status, price, view);

        rooms.add(aRoom);

        if (aRoom.getCategory().equalsIgnoreCase("vip")) {
            this.handleVipRooms(price, view);
        }
        else {
            if (aRoom.getCategory().equalsIgnoreCase("normal")) {
                this.handleNormalRooms(price);
            }
        }
        return true;
    }

    public boolean addRoom(Room aRoom) {
        rooms.add(aRoom);
        return true;
    }

    public Room removeRoom(int RoomNo) {
        for (Room aRoom : rooms) {
            if ((aRoom.getRoomNo()) == (RoomNo)) {
                rooms.remove(aRoom);
                return aRoom;
            }
        }
        return null;
    }

    public Room getRoom(String type, String category) {
        Room aRoom = null;
        for (Room r : rooms) {
            if (r.getType().equals(type) && r.getCategory().equals(category)) {
                aRoom = r;
            }
        }
        return aRoom;
    }

    public Room getRoom(int roomNo) {
        Room aRoom = null;
        for (Room r : rooms) {
            if (r.getRoomNo() == (roomNo)) {
                aRoom = r;
            }
        }
        return aRoom;
    }

    public int numberOfRooms() {
        return rooms.size();
    }

    public String allRoomsData() {
        String s = null;
        for (Room r : rooms) {
            s = s + r.roomData();
        }
        return s;
    }
public double calculateBill(int guestNo,int length){
     Reservation r=new Reservation();
     double total=0;
    Guest g=guestHandler.getGuest(guestNo);
    int roomNo=g.getRoomNo();
   
    if(r.getGuestName().equals(g.getName())&&r.getRoomNo()==roomNo){
        Room room=this.getRoom(roomNo);
        double price=room.getPrice();
        room.setStatus("available");
total=price*length;
}
    return total;
}
    public boolean handleVipRooms(double price, String view) {
        VipRoom vRoom = null;
        for (Room r : rooms) {
            if (r.getCategory().equalsIgnoreCase("vip")) {
                vRoom = new VipRoom(r.getRoomNo(), r.getType(), r.getCategory(),
                        r.getStatus(), price, view);
            }
            r = (VipRoom) vRoom;
        }
        return true;
    }

    public boolean handleNormalRooms(double price) {
        NormalRoom nRoom = null;
        for (Room r : rooms) {
            if (r.getCategory().equalsIgnoreCase("normal")) {
                nRoom = new NormalRoom(r.getRoomNo(), r.getType(), r.getCategory(),
                        r.getStatus(), price);
            }
            r = (NormalRoom) nRoom;
        }
        return true;
    }

    public static void main(String[] args) {

        RoomCatalog roomCat = new RoomCatalog();

        roomCat.registerRoom(100, "Vip", "Single", "Available", 1000, "city");
        roomCat.registerRoom(101, "Normal", "Double","Reserved", 600, "none");
        roomCat.registerRoom(102, "Vip", "Double","Occupied", 2000, "sea");
        roomCat.registerRoom(104, "Normal", "Family","Available", 1000, "none");

        roomCat.registerRoom(123, "Vip", "Family", "Available", 900, "sea");
        roomCat.registerRoom(500, "Normal", "Single", "Occupied", 500, "");

        System.out.println(roomCat.allRoomsData());
    }
}   

    

